<template>
  <!--  Tabla y propiedades de esta  -->
  <div id="app">
    <v-app id="inspire">
      <v-card>
        <v-card-title>
          <v-toolbar-title>
            Pedidos
            
          </v-toolbar-title>
          <v-spacer></v-spacer>
          <v-text-field label="Buscar" single-line hide-details v-model="search"></v-text-field>
        </v-card-title>
        <v-data-table v-model="selected" :headers="headers" :items="items" :search="search">
          <template v-slot:top>
            <v-divider class="mx-4" inset vertical></v-divider>
            <v-spacer></v-spacer>
            <v-dialog v-model="dialog" scrollable max-width="600px">
              <v-card>
                <v-card-title>Detalles de compra #{{selected[0].id}}</v-card-title>
                <v-divider></v-divider>

                <template>
                  <v-card-text>
                    <div class="text--primary">
                      <v-card>
                        <h3 class="headline mb-1">Datos del cliente</h3>

                        <strong>Nombre:</strong>
                        {{selected[0].info.client.name}} {{selected[0].info.client.last_name}}
                        <strong>Correo:</strong>
                        {{selected[0].info.client.email}}
                        <strong>Teléfono:</strong>
                        {{selected[0].info.client.phone}}
                        <br />
                        <strong>Calle:</strong>
                        {{selected[0].info.client.street}}
                        <strong>Colonia:</strong>
                        {{selected[0].info.client.bloc}}
                      </v-card>
                      <br />
                      <v-card>
                        <h3 class="headline mb-1">Resumen de compra</h3>

                        <strong>Productos:</strong>
                        <li
                          v-for="(item) in selected[0].info.products"
                          :key="item.id"
                        >{{item.amount}} {{item.quantity}} {{item.name}} - ${{item.price}}</li>
                        <br />
                        <strong>Canastas:</strong>
                        <li
                          v-for="(item) in selected[0].info.packages"
                          :key="item.id"
                        >{{item.name}} - ${{item.price}}</li>
                      </v-card>
                    </div>
                  </v-card-text>
                </template>

                <v-divider></v-divider>

                <v-card-actions>
                  <!---->
                  <v-container fluid>
                    <v-row>
                      <v-col cols="12" sm="6" xs="6" class="py-2">
                        <v-radio-group cols="12" v-model="stateMode" row>
                          <v-dialog v-model="dialog1" persistent max-width="290">
                            <template v-slot:activator="{ on }">
                              <v-radio label="En proceso" value="En proceso" v-on="on"></v-radio>
                            </template>
                            <v-card>
                              <v-card-title class="headline">
                                Cambio de estado del pedido a
                                <br />"En proceso"
                              </v-card-title>
                              <v-card-actions>
                                <v-spacer></v-spacer>
                                <v-btn color="red darken-1" text @click="dialog1 = false">Cancelar</v-btn>
                                <v-btn color="green darken-1" text @click="stateAction1()">Aceptar</v-btn>
                              </v-card-actions>
                            </v-card>
                          </v-dialog>

                          <v-dialog v-model="dialog2" persistent max-width="290">
                            <template v-slot:activator="{ on }">
                              <v-radio label="Enviado" value="Enviado" v-on="on"></v-radio>
                            </template>
                            <v-card>
                              <v-card-title class="headline">
                                Cambio de estado del pedido a
                                <br />"Enviado"
                                <v-text-field
                                  v-model="newVehicle"
                                  label="Inserte placa de vehículo"
                                  single-line
                                  hide-details
                                  required
                                ></v-text-field>
                              </v-card-title>
                              <v-card-actions>
                                <v-spacer></v-spacer>
                                <v-btn color="red darken-1" text @click="dialog2 = false">Cancelar</v-btn>
                                <v-btn color="green darken-1" text @click="stateAction2()">Aceptar</v-btn>
                              </v-card-actions>
                            </v-card>
                          </v-dialog>

                          <v-dialog v-model="dialog3" persistent max-width="290">
                            <template v-slot:activator="{ on }">
                              <v-radio label="Cancelado" value="Cancelado" v-on="on"></v-radio>
                            </template>
                            <v-card>
                              <v-card-title class="headline">
                                Cambio de estado del pedido a
                                <br />"Cancelado"
                              </v-card-title>
                              <v-card-actions>
                                <v-spacer></v-spacer>
                                <v-btn color="red darken-1" text @click="dialog3 = false">Cancelar</v-btn>
                                <v-btn color="green darken-1" text @click="stateAction3()">Aceptar</v-btn>
                              </v-card-actions>
                            </v-card>
                          </v-dialog>

                          <v-dialog v-model="dialog4" persistent max-width="290">
                            <template v-slot:activator="{ on }">
                              <v-radio label="Recibido" value="Recibido" v-on="on"></v-radio>
                            </template>
                            <v-card>
                              <v-card-title class="headline">
                                Cambio de estado del pedido a
                                <br />"Recibido"
                              </v-card-title>
                              <v-card-actions>
                                <v-spacer></v-spacer>
                                <v-btn color="red darken-1" text @click="dialog4 = false">Cancelar</v-btn>
                                <v-btn color="green darken-1" text @click="stateAction4()">Aceptar</v-btn>
                              </v-card-actions>
                            </v-card>
                          </v-dialog>
                        </v-radio-group>
                      </v-col>
                    </v-row>
                  </v-container>
                  <!---->
                </v-card-actions>
                <v-card-actions>
                  <v-btn color="blue darken-1" text @click="dialog = false">CERRAR</v-btn>
                  <v-btn color="gray darken-2" text @click="sendToPrint()">Imprimir</v-btn>
                </v-card-actions>
              </v-card>
            </v-dialog>
          </template>
          <template v-slot:item.actions="{ item }">
            <v-icon small class="mr-2" @click="openItem(item)">mdi-eye</v-icon>
          </template>
          <template v-slot:no-data></template>

          <v-alert
            slot="no-results"
            :value="true"
            color="error"
            icon="warning"
          >No se encontraron resultados para "{{ search }}".</v-alert>
        </v-data-table>
      </v-card>
    </v-app>
  </div>
</template>

<script>
import 'firebase/auth'
import firebase from "firebase/app";
export default {
  data: () => ({
    newVehicle: "",
    // marketSelected: "Feria",
    // markets: ["SEP", "Feria"],
    stateMode: "",
    toggle_one: 2,
    dialog: false,
    dialog1: false,
    dialog2: false,
    dialog3: false,
    dialog4: false,
    search: "",
    selected: [
      {
        id: "",
        info: {
          client: {
            bloc: "",
            email: "",
            id: "",
            last_name: "",
            name: "",
            phone: "",
            postal_code: "",
            street: ""
          },
          market: "",
          packages: [{ id: "", name: "", price: 0 }],
          products: [],
          status: "",
          total: 0
        }
      }
    ],
    //Los items que contiene el selec acrode a los estados marcados
    headers: [
      {
        text: "Nombre",
        align: "start",
        sortable: false,
        value: "info.client.name"
      },
      { text: "Apellido", value: "info.client.last_name" },
      { text: "Precio del Pedido", value: "info.total" },
      { text: "Colonia", value: "info.client.bloc" },
      { text: "Calle", value: "info.client.street" },
      { text: "Estado", value: "info.status" },
      { text: "Actions", value: "actions", sortable: false }
    ],

    items: [],
    editedIndex: -1,
    editedItem: {
      name: "",
      precioActual: 0,
      nuevoPrecio: 0,
      estado: 0,
      protein: 0
    },
    defaultItem: {
      name: "",
      precioActual: 0,
      nuevoPrecio: 0,
      estado: 0,
      protein: 0
    }
  }),

  watch: {},

  async created() {
    const user = firebase.auth().currentUser
    const userData = await this.$axios.get(
        `http://${process.env.VUE_APP_API_URL}/api/users/${user.uid}`
      );
    const market = userData.data.user.market
    this.initialize(market);
  },

  methods: {
    //Recibe el mercado seleccionado, por default es Feria
    async initialize(mrk) {
      const db = firebase.firestore();
      await db
        .collection("sales")
        .where("market", "==", mrk)
        .onSnapshot(res => {
          const changes = res.docChanges();

          changes.forEach(change => {
            if (change.type === "added") {
              this.items.push({
                id: change.doc.id,
                info: change.doc.data()
              });
            }
            if (change.type === "removed") {
              for (var i = 0; i < this.items.length; i++) {
                if (this.items[i].id == change.doc.id) {
                  this.items.splice(i, 1);
                  break;
                }
              }
            }
            if (change.type === "modified") {
              for (let i = 0; i < this.items.length; i++) {
                if (this.items[i].id == change.doc.id) {
                  let newData = change.doc.data();
                  this.items[i].id = change.doc.id;
                  this.items[i].info = newData;
                  break;
                }
              }
            }
          });
        });
    },
    openItem(item) {
      let temp = [];
      temp.push(item);
      this.selected = temp;
      this.dialog = true;
      this.stateMode = item.info.status;
    },
    stateAction1() {
      this.dialog1 = false;
      this.stateMode = "En proceso";
      this.newStatus("En proceso");
    },
    stateAction2() {
      this.dialog2 = false;
      this.stateMode = "Enviado";
      this.setVehicle();
      this.newStatus("Enviado");
    },
    stateAction3() {
      this.dialog3 = false;
      this.stateMode = "Cancelado";
      this.newStatus("Cancelado");
    },
    stateAction4() {
      this.dialog4 = false;
      this.stateMode = "Recibido";
      this.newStatus("Recibido");
    },
    async newStatus(newStatus) {
      const db = firebase.firestore();
      await db
        .collection("sales")
        .doc(this.selected[0].id)
        .update({
          status: newStatus
        });
    },
    // actionSelec() {
    //   this.items = [];
    //   this.initialize(this.marketSelected);
    // },
    sendToPrint() {
      this.$emit("printOrder", true, this.selected[0]);
    },
    async setVehicle() {
      const db = firebase.firestore();
      await db
        .collection("sales")
        .doc(this.selected[0].id)
        .update({
          vehicle: this.newVehicle
        });
      this.newVehicle = "";
    }
  }
};
</script>
